diff -ruN vdr-1.7.25/CONTRIBUTORS vdr-1.7.26/CONTRIBUTORS
--- vdr-1.7.25/CONTRIBUTORS	2012-03-02 16:49:57.000000000 +0100
+++ vdr-1.7.26/CONTRIBUTORS	2012-03-03 15:06:06.000000000 +0100
@@ -2284,6 +2284,7 @@
  for adding support for HbbTV to libsi
  for fixing cRecording::LengthInSeconds(), which wrongfully rounded the result to full
  minutes
+ for suggesting to check for NULL in cOsd::AddPixmap()
 
 Pekka Mauno <pekka.mauno@iki.fi>
  for fixing cSchedule::GetFollowingEvent() in case there is currently no present
@@ -2773,6 +2774,7 @@
 Frank Neumann <fnu@yavdr.org>
  for suggesting to reduce the thread and I/O priority cCuttingThread::Action()
  for reporting a problem with tuning timeouts when using SCR with multiple tuners
+ for fixing the German translation of "VDR will shut down in %s minutes"
 
 Gerald Dachs <vdr@dachsweb.de>
  for reporting a problem with checking for minimum line length of 21 characters in
diff -ruN vdr-1.7.25/HISTORY vdr-1.7.26/HISTORY
--- vdr-1.7.25/HISTORY	2012-03-03 12:51:32.000000000 +0100
+++ vdr-1.7.26/HISTORY	2012-03-10 15:28:06.000000000 +0100
@@ -6959,3 +6959,53 @@
   is actually going to be switched or has actually been switched successfully"
   which was made in version 1.1.10, so please report if this has any unwanted
   side effects.
+
+2012-03-10: Version 1.7.26
+
+- Now checking for NULL in cOsd::AddPixmap() (suggested by Christoph Haubrich).
+- Fixed the German translation of "VDR will shut down in %s minutes" (thanks to
+  Frank Neumann).
+- The replay progress display is now turned on whenever a mark is toggled (not
+  only when one is set).
+- Toggling a mark now restarts the timeout of the replay progress display.
+- Fixed a possible race condition with the SVDRP commands CLRE and PUTE, where
+  EPG data from the transponder could be handled even though it shouldn't be
+  handled for 10 seconds.
+- Added some missing member initializations in cBitmap.
+- Improved displaying the play mode in the ST:TNG skin.
+- Made the ST:TNG skin the default in case the user selected skin is not available.
+- Improved displaying signal strength and quality in the ST:TNG skin's channel
+  display.
+- Fixed switching devices to the transponders of VPS recordings in case there
+  are only bonded devices. The cDevice's "avoid device" mechanism has been replaced
+  by using "occupied".
+- Fixed selecting devices for the EPG scan in case the primary device is bonded
+  with an other one.
+- Removed the calls to EITScanner.UsesDevice(this) from dvb[hs]ddevice.c, because
+  the code following these calls is only executed if LiveView is true, which is
+  never the case when the EITScanner switches to a channel.
+- Removed the obsolete function cEITScanner::UsesDevice(). If a plugin has used this
+  function to find out whether a call to its cStatus::ChannelSwitch() function was
+  due to a live channel switch, it can use that function's new parameter LiveView.
+  Any plugins that implement cStatus::ChannelSwitch() need to add the parameter
+  'bool LiveView' to that function.
+- Fixed parsing channel data in case the audio pid is 0. On channels that only
+  broadcast Dolby Digital audio there were sometimes log entries like
+  "changing pids of channel ... from ... to ..." with no apparent difference
+  between the old and new set of pids.
+- Fixed checking pids in case a channel has only Dolby Digital audio.
+- The Green button in the "Edit timer" menu can now be used to toggle between single
+  shot and repeating timers. This is the same as pressing '0' when the "Day" field
+  is selected, but it works at any time (and is more obvious).
+- Revoked "If the first event in a schedule has a table id of 0x00, any incoming EIT data for
+  that schedule from the DVB stream will be completely ignored".
+- Added a new plugin interface for implementing EPG handlers.
+  + A plugin can implement an EPG handler by creating an object derived from
+    cEpgHandler and implementing the necessary member functions.
+  + The special handling of events with table id 0x00 has been dropped.
+    For backwards compatibility EPG events with table ids lower than 0x4E will
+    be treated as if they had a table id of 0x4E, and the new plugin 'epgtableid0'
+    can be used to have them handled like in previous versions.
+  + The default table id for a newly created cEvent has been changed to 0xFF,
+    which is higher than any normal table id that is broadcast in the EIT data.
+  See PLUGINS.html, section "Electronic Program Guide" for more information.
diff -ruN vdr-1.7.25/PLUGINS/src/dvbhddevice/dvbhdffdevice.c vdr-1.7.26/PLUGINS/src/dvbhddevice/dvbhdffdevice.c
--- vdr-1.7.25/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2012-02-28 10:18:56.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2012-03-07 14:52:41.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbhdffdevice.c 1.40 2012/02/28 09:18:56 kls Exp $
+ * $Id: dvbhdffdevice.c 1.41 2012/03/07 13:52:41 kls Exp $
  */
 
 #include <stdint.h>
@@ -298,13 +298,6 @@
   if (!cDvbDevice::SetChannelDevice(Channel, LiveView))
      return false;
 
-  // If this channel switch was requested by the EITScanner we don't wait for
-  // a lock and don't set any live PIDs (the EITScanner will wait for the lock
-  // by itself before setting any filters):
-
-  if (EITScanner.UsesDevice(this)) //XXX
-     return true;
-
   // PID settings:
 
   if (TurnOnLivePIDs) {
diff -ruN vdr-1.7.25/PLUGINS/src/dvbsddevice/HISTORY vdr-1.7.26/PLUGINS/src/dvbsddevice/HISTORY
--- vdr-1.7.25/PLUGINS/src/dvbsddevice/HISTORY	2011-08-27 13:36:27.000000000 +0200
+++ vdr-1.7.26/PLUGINS/src/dvbsddevice/HISTORY	2012-03-07 15:00:28.000000000 +0100
@@ -23,3 +23,9 @@
 2011-08-27: Version 0.0.5
 
 - Added option --outputonly to use the device only for output (thanks to Udo Richter).
+
+2012-03-07: Version 0.06
+
+- Removed the call to EITScanner.UsesDevice(this) from dvbsddevice.c, because
+  the code following these calls is only executed if LiveView is true, which is
+  never the case when the EITScanner switches to a channel.
diff -ruN vdr-1.7.25/PLUGINS/src/dvbsddevice/dvbsddevice.c vdr-1.7.26/PLUGINS/src/dvbsddevice/dvbsddevice.c
--- vdr-1.7.25/PLUGINS/src/dvbsddevice/dvbsddevice.c	2011-08-27 13:34:58.000000000 +0200
+++ vdr-1.7.26/PLUGINS/src/dvbsddevice/dvbsddevice.c	2012-03-07 14:58:08.000000000 +0100
@@ -3,14 +3,14 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbsddevice.c 1.5 2011/08/27 11:34:58 kls Exp $
+ * $Id: dvbsddevice.c 1.6 2012/03/07 13:58:08 kls Exp $
  */
 
 #include <getopt.h>
 #include <vdr/plugin.h>
 #include "dvbsdffdevice.h"
 
-static const char *VERSION        = "0.0.5";
+static const char *VERSION        = "0.0.6";
 static const char *DESCRIPTION    = "SD Full Featured DVB device";
 
 class cPluginDvbsddevice : public cPlugin {
diff -ruN vdr-1.7.25/PLUGINS/src/dvbsddevice/dvbsdffdevice.c vdr-1.7.26/PLUGINS/src/dvbsddevice/dvbsdffdevice.c
--- vdr-1.7.25/PLUGINS/src/dvbsddevice/dvbsdffdevice.c	2012-02-15 14:15:05.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/dvbsddevice/dvbsdffdevice.c	2012-03-07 14:52:48.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbsdffdevice.c 2.31 2012/02/15 13:15:05 kls Exp $
+ * $Id: dvbsdffdevice.c 2.32 2012/03/07 13:52:48 kls Exp $
  */
 
 #include "dvbsdffdevice.h"
@@ -421,13 +421,6 @@
   if (!cDvbDevice::SetChannelDevice(Channel, LiveView))
      return false;
 
-  // If this channel switch was requested by the EITScanner we don't wait for
-  // a lock and don't set any live PIDs (the EITScanner will wait for the lock
-  // by itself before setting any filters):
-
-  if (EITScanner.UsesDevice(this)) //XXX
-     return true;
-
   // PID settings:
 
   if (TurnOnLivePIDs) {
diff -ruN vdr-1.7.25/PLUGINS/src/epgtableid0/COPYING vdr-1.7.26/PLUGINS/src/epgtableid0/COPYING
--- vdr-1.7.25/PLUGINS/src/epgtableid0/COPYING	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/epgtableid0/COPYING	2012-03-10 15:23:58.000000000 +0100
@@ -0,0 +1,340 @@
+		    GNU GENERAL PUBLIC LICENSE
+		       Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.
+ 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+			    Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users.  This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it.  (Some other Free Software Foundation software is covered by
+the GNU Lesser General Public License instead.)  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have.  You must make sure that they, too, receive or can get the
+source code.  And you must show them these terms so they know their
+rights.
+
+  We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+  Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software.  If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary.  To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+		    GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+			    NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
+
+	    How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+    Gnomovision version 69, Copyright (C) year name of author
+    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+  `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+  <signature of Ty Coon>, 1 April 1989
+  Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs.  If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library.  If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.
diff -ruN vdr-1.7.25/PLUGINS/src/epgtableid0/HISTORY vdr-1.7.26/PLUGINS/src/epgtableid0/HISTORY
--- vdr-1.7.25/PLUGINS/src/epgtableid0/HISTORY	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/epgtableid0/HISTORY	2012-03-10 15:23:58.000000000 +0100
@@ -0,0 +1,6 @@
+VDR Plugin 'epgtableid0' Revision History
+-----------------------------------------
+
+2012-03-10: Version 0.0.1
+
+- Initial revision.
diff -ruN vdr-1.7.25/PLUGINS/src/epgtableid0/Makefile vdr-1.7.26/PLUGINS/src/epgtableid0/Makefile
--- vdr-1.7.25/PLUGINS/src/epgtableid0/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/epgtableid0/Makefile	2012-03-10 15:23:58.000000000 +0100
@@ -0,0 +1,114 @@
+#
+# Makefile for a Video Disk Recorder plugin
+#
+# $Id: Makefile 1.1 2012/03/10 14:23:58 kls Exp $
+
+# The official name of this plugin.
+# This name will be used in the '-P...' option of VDR to load the plugin.
+# By default the main source file also carries this name.
+# IMPORTANT: the presence of this macro is important for the Make.config
+# file. So it must be defined, even if it is not used here!
+#
+PLUGIN = epgtableid0
+
+### The version number of this plugin (taken from the main source file):
+
+VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ print $$6 }' | sed -e 's/[";]//g')
+
+### The C++ compiler and options:
+
+CXX      ?= g++
+CXXFLAGS ?= -g -O3 -Wall -Woverloaded-virtual -Wno-parentheses
+
+### The directory environment:
+
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
+
+### Make sure that necessary options are included:
+
+include $(VDRDIR)/Make.global
+
+### Allow user defined options to overwrite defaults:
+
+-include $(VDRDIR)/Make.config
+
+### The version number of VDR's plugin API (taken from VDR's "config.h"):
+
+APIVERSION = $(shell sed -ne '/define APIVERSION/s/^.*"\(.*\)".*$$/\1/p' $(VDRDIR)/config.h)
+
+### The name of the distribution archive:
+
+ARCHIVE = $(PLUGIN)-$(VERSION)
+PACKAGE = vdr-$(ARCHIVE)
+
+### Includes and Defines (add further entries here):
+
+INCLUDES += -I$(VDRDIR)/include
+
+DEFINES += -D_GNU_SOURCE -DPLUGIN_NAME_I18N='"$(PLUGIN)"'
+
+### The object files (add further files here):
+
+OBJS = $(PLUGIN).o
+
+### The main target:
+
+all: libvdr-$(PLUGIN).so i18n
+
+### Implicit rules:
+
+%.o: %.c
+	$(CXX) $(CXXFLAGS) -c $(DEFINES) $(INCLUDES) $<
+
+### Dependencies:
+
+MAKEDEP = $(CXX) -MM -MG
+DEPFILE = .dependencies
+$(DEPFILE): Makefile
+	@$(MAKEDEP) $(DEFINES) $(INCLUDES) $(OBJS:%.o=%.c) > $@
+
+-include $(DEPFILE)
+
+### Internationalization (I18N):
+
+PODIR     = po
+LOCALEDIR = $(VDRDIR)/locale
+I18Npo    = $(wildcard $(PODIR)/*.po)
+I18Nmsgs  = $(addprefix $(LOCALEDIR)/, $(addsuffix /LC_MESSAGES/vdr-$(PLUGIN).mo, $(notdir $(foreach file, $(I18Npo), $(basename $(file))))))
+I18Npot   = $(PODIR)/$(PLUGIN).pot
+
+%.mo: %.po
+	msgfmt -c -o $@ $<
+
+$(I18Npot): $(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --package-name=vdr-$(PLUGIN) --package-version=$(VERSION) --msgid-bugs-address='<see README>' -o $@ $^
+
+%.po: $(I18Npot)
+	msgmerge -U --no-wrap --no-location --backup=none -q $@ $<
+	@touch $@
+
+$(I18Nmsgs): $(LOCALEDIR)/%/LC_MESSAGES/vdr-$(PLUGIN).mo: $(PODIR)/%.mo
+	@mkdir -p $(dir $@)
+	cp $< $@
+
+.PHONY: i18n
+i18n: $(I18Nmsgs) $(I18Npot)
+
+### Targets:
+
+libvdr-$(PLUGIN).so: $(OBJS)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) -shared $(OBJS) -o $@
+	@cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
+
+dist: $(I18Npo) clean
+	@-rm -rf $(TMPDIR)/$(ARCHIVE)
+	@mkdir $(TMPDIR)/$(ARCHIVE)
+	@cp -a * $(TMPDIR)/$(ARCHIVE)
+	@tar czf $(PACKAGE).tgz -C $(TMPDIR) $(ARCHIVE)
+	@-rm -rf $(TMPDIR)/$(ARCHIVE)
+	@echo Distribution package created as $(PACKAGE).tgz
+
+clean:
+	@-rm -f $(OBJS) $(DEPFILE) *.so *.tgz core* *~ $(PODIR)/*.mo $(PODIR)/*.pot
diff -ruN vdr-1.7.25/PLUGINS/src/epgtableid0/README vdr-1.7.26/PLUGINS/src/epgtableid0/README
--- vdr-1.7.25/PLUGINS/src/epgtableid0/README	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/epgtableid0/README	2012-03-10 15:26:10.000000000 +0100
@@ -0,0 +1,19 @@
+This is a "plugin" for the Video Disk Recorder (VDR).
+
+Written by:                  Klaus Schmidinger <kls@tvdr.de>
+
+Project's homepage:          http://www.tvdr.de
+
+Latest version available at: http://www.tvdr.de
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
+
+Description:
+
+The special handling of EPG events with table id 0x00 has been dropped
+in VDR version 1.7.26, and replaced by a more felxible "EPG Handler"
+concept. You can use this plugin to get the previous functionality back.
diff -ruN vdr-1.7.25/PLUGINS/src/epgtableid0/epgtableid0.c vdr-1.7.26/PLUGINS/src/epgtableid0/epgtableid0.c
--- vdr-1.7.25/PLUGINS/src/epgtableid0/epgtableid0.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/epgtableid0/epgtableid0.c	2012-03-10 16:10:43.000000000 +0100
@@ -0,0 +1,98 @@
+/*
+ * epgtableid0.c: A plugin for the Video Disk Recorder
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: epgtableid0.c 1.1 2012/03/10 15:10:43 kls Exp $
+ */
+
+#include <vdr/epg.h>
+#include <vdr/plugin.h>
+
+static const char *VERSION        = "0.0.1";
+static const char *DESCRIPTION    = "EPG handler for events with table id 0x00";
+
+// --- cTable0Handler --------------------------------------------------------
+
+class cTable0Handler : public cEpgHandler {
+private:
+  bool Ignore(cEvent *Event) { return Event->TableID() == 0x00; }
+public:
+  virtual bool SetEventID(cEvent *Event, tEventID EventID);
+  virtual bool SetStartTime(cEvent *Event, time_t StartTime);
+  virtual bool SetDuration(cEvent *Event, int Duration);
+  virtual bool SetTitle(cEvent *Event, const char *Title);
+  virtual bool SetShortText(cEvent *Event, const char *ShortText);
+  virtual bool SetDescription(cEvent *Event, const char *Description);
+  virtual bool SetContents(cEvent *Event, uchar *Contents);
+  virtual bool SetParentalRating(cEvent *Event, int ParentalRating);
+  virtual bool SetVps(cEvent *Event, time_t Vps);
+  virtual bool FixEpgBugs(cEvent *Event);
+  };
+
+bool cTable0Handler::SetEventID(cEvent *Event, tEventID EventID)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetStartTime(cEvent *Event, time_t StartTime)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetDuration(cEvent *Event, int Duration)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetTitle(cEvent *Event, const char *Title)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetShortText(cEvent *Event, const char *ShortText)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetDescription(cEvent *Event, const char *Description)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetContents(cEvent *Event, uchar *Contents)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetParentalRating(cEvent *Event, int ParentalRating)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetVps(cEvent *Event, time_t Vps)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::FixEpgBugs(cEvent *Event)
+{
+  return Ignore(Event);
+}
+
+// --- cPluginEpgtableid0 ----------------------------------------------------
+
+class cPluginEpgtableid0 : public cPlugin {
+public:
+  virtual const char *Version(void) { return VERSION; }
+  virtual const char *Description(void) { return DESCRIPTION; }
+  virtual bool Initialize(void);
+  };
+
+bool cPluginEpgtableid0::Initialize(void)
+{
+  new cTable0Handler;
+  return true;
+}
+
+VDRPLUGINCREATOR(cPluginEpgtableid0); // Don't touch this!
diff -ruN vdr-1.7.25/PLUGINS/src/rcu/HISTORY vdr-1.7.26/PLUGINS/src/rcu/HISTORY
--- vdr-1.7.25/PLUGINS/src/rcu/HISTORY	2012-02-27 11:46:08.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/rcu/HISTORY	2012-03-07 15:23:27.000000000 +0100
@@ -4,3 +4,7 @@
 2012-02-27: Version 0.0.1
 
 - Initial revision.
+
+2012-03-07: Version 0.0.2
+
+- Added new parameter LiveView to ChannelSwitch().
diff -ruN vdr-1.7.25/PLUGINS/src/rcu/rcu.c vdr-1.7.26/PLUGINS/src/rcu/rcu.c
--- vdr-1.7.25/PLUGINS/src/rcu/rcu.c	2012-02-27 12:49:51.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/rcu/rcu.c	2012-03-07 15:22:44.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: rcu.c 1.1 2012/02/27 11:49:51 kls Exp $
+ * $Id: rcu.c 1.2 2012/03/07 14:22:44 kls Exp $
  */
 
 #include <getopt.h>
@@ -16,7 +16,7 @@
 #include <vdr/thread.h>
 #include <vdr/tools.h>
 
-static const char *VERSION        = "0.0.1";
+static const char *VERSION        = "0.0.2";
 static const char *DESCRIPTION    = "Remote Control Unit";
 
 #define REPEATLIMIT      150 // ms
@@ -44,7 +44,7 @@
   void SetString(const char *s);
   bool DetectCode(unsigned char *Code);
   virtual void Action(void);
-  virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber);
+  virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber, bool LiveView);
   virtual void Recording(const cDevice *Device, const char *Name, const char *FileName, bool On);
 public:
   cRcuRemote(const char *DeviceName);
@@ -353,9 +353,9 @@
   return false;
 }
 
-void cRcuRemote::ChannelSwitch(const cDevice *Device, int ChannelNumber)
+void cRcuRemote::ChannelSwitch(const cDevice *Device, int ChannelNumber, bool LiveView)
 {
-  if (ChannelNumber && Device->IsPrimaryDevice())
+  if (ChannelNumber && LiveView)
      SetNumber(cDevice::CurrentChannel());
 }
 
diff -ruN vdr-1.7.25/PLUGINS.html vdr-1.7.26/PLUGINS.html
--- vdr-1.7.25/PLUGINS.html	2012-03-01 10:52:01.000000000 +0100
+++ vdr-1.7.26/PLUGINS.html	2012-03-09 10:49:29.000000000 +0100
@@ -21,6 +21,9 @@
 .modified {
     background-color: #FFDDDD;
 }
+modified {
+    background-color: #FFDDDD;
+}
 </style>
 </head>
 <body>
@@ -34,9 +37,9 @@
 <a href="mailto:kls@tvdr.de">kls@tvdr.de</a><br>
 <a href="http://www.tvdr.de">www.tvdr.de</a>
 </div>
-<div class="modified">
-Important modifications introduced since version 1.6 are marked like this.
-</div modified>
+<div class="center">
+<modified>Important modifications introduced since version 1.6 are marked like this.</modified>
+</div>
 <p>
 VDR provides an easy to use plugin interface that allows additional functionality
 to be added to the program by implementing a dynamically loadable library file.
@@ -99,6 +102,7 @@
 <li><a href="#Audio">Audio</a>
 <li><a href="#Remote Control">Remote Control</a>
 <li><a href="#Conditional Access">Conditional Access</a>
+<li><modified><a href="#Electronic Program Guide">Electronic Program Guide</modified></a>
 </ul>
 </ul>
 
@@ -1221,10 +1225,10 @@
 
 class cMyStatusMonitor : public cStatus {
 protected:
-  virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber);
+  virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber<modified>, bool LiveView</modified>);
   };
 
-void cMyStatusMonitor::ChannelSwitch(const cDevice *Device, int ChannelNumber)
+void cMyStatusMonitor::ChannelSwitch(const cDevice *Device, int ChannelNumber<modified>, bool LiveView</modified>)
 {
   if (ChannelNumber)
      dsyslog("channel switched to %d on DVB %d", ChannelNumber, Device-&gt;CardIndex());
@@ -1510,9 +1514,7 @@
 PID (for example the Teletext PID). In order to not interfere with other recording
 operations, it sets its priority to <tt>-1</tt> (any negative value will allow
 a <tt>cReceiver</tt> to be detached from its <tt>cDevice</tt> at any time
-<div class="modified">
-in favor of a timer recording or live viewing).
-</div modified>
+<modified>in favor of a timer recording or live viewing</modified>).
 <p>
 Once a <tt>cReceiver</tt> has been created, it needs to be <i>attached</i> to
 a <tt>cDevice</tt>:
@@ -1528,9 +1530,9 @@
 video stream (this may be different from the primary device in case of <i>Transfer
 Mode</i>).
 <p>
-<div class="modified">
+<modified>
 The <tt>cReceiver</tt> must be detached from its device before it is deleted.
-</div modified>
+</modified>
 
 <hr><h2><a name="Filters">Filters</a></h2>
 
@@ -1808,9 +1810,7 @@
 selecting which channel it shall tune to:
 
 <p><table><tr><td class="code"><pre>
-<div class="modified">
-virtual int NumProvidedSystems(void) const;
-</div modified>
+<modified>virtual int NumProvidedSystems(void) const;</modified>
 virtual bool ProvidesSource(int Source) const;
 virtual bool ProvidesTransponder(const cChannel *Channel) const;
 virtual bool ProvidesChannel(const cChannel *Channel, int Priority = -1, bool *NeedsDetachReceivers = NULL) const;
@@ -1859,9 +1859,7 @@
 virtual bool CanReplay(void) const;
 virtual bool SetPlayMode(ePlayMode PlayMode);
 virtual int64_t GetSTC(void);
-<div class="modified">
-virtual bool IsPlayingVideo(void) const;
-</div modified>
+<modified>virtual bool IsPlayingVideo(void) const;</modified>
 virtual bool HasIBPTrickSpeed(void);
 virtual void TrickSpeed(int Speed);
 virtual void Clear(void);
@@ -1938,13 +1936,13 @@
 The OSD provider object is allocated on the heap and shall not be deleted
 (it will be deleted automatically in case a different device sets up an OSD
 provider, or when the program ends).
-
+<p>
 Note that an OSD implementation need not be physically linked to the device
 in any way. All it needs to make sure is that the OSD will be visible to the
 user - whether this goes through OSD facilities of the physical device (like
 a "full featured" DVB card) or through a graphics adapter that overlays its
 output with the video signal, doesn't matter.
-
+<p>
 <div class="modified">
 In order to be able to determine the proper size of the OSD, the device
 should implement the function
@@ -2215,5 +2213,37 @@
 
 See the description of this function in <tt>ci.h</tt> for details.
 
+<div class="modified">
+<hr><h2><a name="Electronic Program Guide">Electronic Program Guide</a></h2>
+
+<div class="blurb">The grass is always greener on the other side...</div><p>
+
+In case the <i>Electronic Program Guide (EPG)</i> provided by the broadcaster
+isn't sufficient for your taste, you can implement a <tt>cEpgHandler</tt> to
+improve it from external sources. For instance, to replace the description
+of the broadcaster's EPG with one from some external database, you could do:
+
+<p><table><tr><td class="code"><pre>
+#include &lt;vdr/epg.h&gt;
+
+class cMyEpgHandler : public cEpgHandler {
+public:
+  virtual bool SetDescription(cEvent *Event, const char *Description);
+  };
+
+bool cMyEpgHandler::SetDescription(cEvent *Event, const char *Description)
+{
+  Event-&gt;SetDescription(DescriptionFromDatabase(Event));
+  return true;
+}
+</pre></td></tr></table><p>
+
+where <tt>DescriptionFromDatabase()</tt> would derive the description of the
+ given event from some external source. Note that the function returns <tt>true</tt>
+to signal VDR that no other EPG handlers shall be queried after this one.
+<p>
+See <tt>VDR/epg.h</tt> for details.
+</div modified>
+
 </body>
 </html>
diff -ruN vdr-1.7.25/channels.c vdr-1.7.26/channels.c
--- vdr-1.7.25/channels.c	2011-08-26 14:44:21.000000000 +0200
+++ vdr-1.7.26/channels.c	2012-03-07 17:50:15.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.c 2.19 2011/08/26 12:44:21 kls Exp $
+ * $Id: channels.c 2.20 2012/03/07 16:50:15 kls Exp $
  */
 
 #include "channels.h"
@@ -619,7 +619,8 @@
                        }
                     else
                        *alangs[NumApids] = 0;
-                    apids[NumApids++] = strtol(q, NULL, 10);
+                    if ((apids[NumApids] = strtol(q, NULL, 10)) != 0)
+                       NumApids++;
                     }
                  else
                     esyslog("ERROR: too many APIDs!"); // no need to set ok to 'false'
@@ -647,7 +648,8 @@
                           }
                        else
                           *dlangs[NumDpids] = 0;
-                       dpids[NumDpids++] = strtol(q, NULL, 10);
+                       if ((dpids[NumDpids] = strtol(q, NULL, 10)) != 0)
+                          NumDpids++;
                        }
                     else
                        esyslog("ERROR: too many DPIDs!"); // no need to set ok to 'false'
diff -ruN vdr-1.7.25/config.h vdr-1.7.26/config.h
--- vdr-1.7.25/config.h	2012-02-29 13:28:01.000000000 +0100
+++ vdr-1.7.26/config.h	2012-03-03 14:25:22.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.43 2012/02/29 12:28:01 kls Exp $
+ * $Id: config.h 2.44 2012/03/03 13:25:22 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.25"
-#define VDRVERSNUM   10725  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.26"
+#define VDRVERSNUM   10726  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.25"
-#define APIVERSNUM   10725  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.26"
+#define APIVERSNUM   10726  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
diff -ruN vdr-1.7.25/device.c vdr-1.7.26/device.c
--- vdr-1.7.25/device.c	2012-03-03 12:43:05.000000000 +0100
+++ vdr-1.7.26/device.c	2012-03-07 15:17:49.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.55 2012/03/03 11:43:05 kls Exp $
+ * $Id: device.c 2.57 2012/03/07 14:17:49 kls Exp $
  */
 
 #include "device.h"
@@ -68,7 +68,6 @@
 int cDevice::currentChannel = 1;
 cDevice *cDevice::device[MAXDEVICES] = { NULL };
 cDevice *cDevice::primaryDevice = NULL;
-cDevice *cDevice::avoidDevice = NULL;
 cList<cDeviceHook> cDevice::deviceHooks;
 
 cDevice::cDevice(void)
@@ -228,8 +227,6 @@
 
 cDevice *cDevice::GetDevice(const cChannel *Channel, int Priority, bool LiveView, bool Query)
 {
-  cDevice *AvoidDevice = avoidDevice;
-  avoidDevice = NULL;
   // Collect the current priorities of all CAM slots that can decrypt the channel:
   int NumCamSlots = CamSlots.Count();
   int SlotPriority[NumCamSlots];
@@ -259,8 +256,6 @@
       if (NumUsableSlots && SlotPriority[j] > MAXPRIORITY)
          continue; // there is no CAM available in this slot
       for (int i = 0; i < numDevices; i++) {
-          if (device[i] == AvoidDevice)
-             continue; // this device shall be temporarily avoided
           if (Channel->Ca() && Channel->Ca() <= CA_DVB_MAX && Channel->Ca() != device[i]->CardIndex() + 1)
              continue; // a specific card was requested, but not this one
           if (NumUsableSlots && !CamSlots.Get(j)->Assign(device[i], true))
@@ -319,6 +314,26 @@
   return d;
 }
 
+cDevice *cDevice::GetDeviceForTransponder(const cChannel *Channel, int Priority)
+{
+  cDevice *Device = NULL;
+  for (int i = 0; i < cDevice::NumDevices(); i++) {
+      if (cDevice *d = cDevice::GetDevice(i)) {
+         if (d->IsTunedToTransponder(Channel))
+            return d; // if any device is tuned to the transponder, we're done
+         if (d->ProvidesTransponder(Channel)) {
+            if (d->MaySwitchTransponder(Channel))
+               Device = d; // this device may switch to the transponder without disturbing any receiver or live view
+            else if (!d->Occupied()) {
+               if (d->Priority() < Priority && (!Device || d->Priority() < Device->Priority()))
+                  Device = d; // use this one only if no other with less impact can be found
+               }
+            }
+         }
+      }
+  return Device;
+}
+
 bool cDevice::HasCi(void)
 {
   return false;
@@ -708,7 +723,7 @@
 
 eSetChannelResult cDevice::SetChannel(const cChannel *Channel, bool LiveView)
 {
-  cStatus::MsgChannelSwitch(this, 0);
+  cStatus::MsgChannelSwitch(this, 0, LiveView);
 
   if (LiveView) {
      StopReplay();
@@ -778,7 +793,7 @@
            EnsureAudioTrack(true);
         EnsureSubtitleTrack();
         }
-     cStatus::MsgChannelSwitch(this, Channel->Number()); // only report status if channel switch successfull
+     cStatus::MsgChannelSwitch(this, Channel->Number(), LiveView); // only report status if channel switch successfull
      }
 
   return Result;
diff -ruN vdr-1.7.25/device.h vdr-1.7.26/device.h
--- vdr-1.7.25/device.h	2012-03-02 11:23:13.000000000 +0100
+++ vdr-1.7.26/device.h	2012-03-06 13:13:46.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 2.36 2012/03/02 10:23:13 kls Exp $
+ * $Id: device.h 2.37 2012/03/06 12:13:46 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -109,7 +109,6 @@
   static int useDevice;
   static cDevice *device[MAXDEVICES];
   static cDevice *primaryDevice;
-  static cDevice *avoidDevice;
 public:
   static int NumDevices(void) { return numDevices; }
          ///< Returns the total number of devices.
@@ -158,9 +157,11 @@
          ///< in order to just determine whether a device is available for the given
          ///< Channel.
          ///< See also ProvidesChannel().
-  static void SetAvoidDevice(cDevice *Device) { avoidDevice = Device; }
-         ///< Sets the given Device to be temporarily avoided in the next call to
-         ///< GetDevice(const cChannel, int, bool).
+  static cDevice *GetDeviceForTransponder(const cChannel *Channel, int Priority);
+         ///< Returns a device that is not currently "occupied" and can be tuned to
+         ///< the transponder of the given Channel, without disturbing any receiver
+         ///< at priorities higher or equal to Priority.
+         ///< If no such device is currently available, NULL will be returned.
   static void Shutdown(void);
          ///< Closes down all devices.
          ///< Must be called at the end of the program.
diff -ruN vdr-1.7.25/dvbdevice.c vdr-1.7.26/dvbdevice.c
--- vdr-1.7.25/dvbdevice.c	2012-02-29 13:23:43.000000000 +0100
+++ vdr-1.7.26/dvbdevice.c	2012-03-08 10:49:58.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 2.65 2012/02/29 12:23:43 kls Exp $
+ * $Id: dvbdevice.c 2.67 2012/03/08 09:49:58 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -420,7 +420,7 @@
   if (cDvbTuner *t = bondedTuner) {
      cString BondingParams = GetBondingParams(Channel);
      do {
-        if (t->device->Receiving() || ConsiderOccupied && t->device->Occupied()) {
+        if (t->device->Priority() > IDLEPRIORITY || ConsiderOccupied && t->device->Occupied()) {
            if (strcmp(BondingParams, t->GetBondingParams()) != 0)
               return false;
            }
@@ -1446,7 +1446,7 @@
      if (Priority >= 0) {
         if (Receiving()) {
            if (dvbTuner->IsTunedTo(Channel)) {
-              if (Channel->Vpid() && !HasPid(Channel->Vpid()) || Channel->Apid(0) && !HasPid(Channel->Apid(0))) {
+              if (Channel->Vpid() && !HasPid(Channel->Vpid()) || Channel->Apid(0) && !HasPid(Channel->Apid(0)) || Channel->Dpid(0) && !HasPid(Channel->Dpid(0))) {
                  if (CamSlot() && Channel->Ca() >= CA_ENCRYPTED_MIN) {
                     if (CamSlot()->CanDecrypt(Channel))
                        result = true;
diff -ruN vdr-1.7.25/eit.c vdr-1.7.26/eit.c
--- vdr-1.7.25/eit.c	2012-02-25 16:25:51.000000000 +0100
+++ vdr-1.7.26/eit.c	2012-03-10 15:43:52.000000000 +0100
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 2.13 2012/02/25 15:25:51 kls Exp $
+ * $Id: eit.c 2.15 2012/03/10 14:43:52 kls Exp $
  */
 
 #include "eit.h"
@@ -36,20 +36,13 @@
   cChannel *channel = Channels.GetByChannelID(channelID, true);
   if (!channel)
      return; // only collect data for known channels
+  if (EpgHandlers.IgnoreChannel(channel))
+     return;
 
   cSchedule *pSchedule = (cSchedule *)Schedules->GetSchedule(channel, true);
-  if (pSchedule) {
-     if (cEvent *Event = pSchedule->Events()->First()) {
-        if (Event->TableID() == 0x00)
-           return; // never touch schedules with events from external sources
-        }
-     }
-  else
-     return;
 
   bool Empty = true;
   bool Modified = false;
-  bool HasExternalData = false;
   time_t SegmentStart = 0;
   time_t SegmentEnd = 0;
   time_t Now = time(NULL);
@@ -61,7 +54,8 @@
 
   SI::EIT::Event SiEitEvent;
   for (SI::Loop::Iterator it; eventLoop.getNext(SiEitEvent, it); ) {
-      bool ExternalData = false;
+      if (EpgHandlers.HandleEitEvent(pSchedule, &SiEitEvent, Tid, getVersionNumber()))
+         continue; // an EPG handler has done all of the processing
       time_t StartTime = SiEitEvent.getStartTime();
       int Duration = SiEitEvent.getDuration();
       // Drop bogus events - but keep NVOD reference events, where all bits of the start time field are set to 1, resulting in a negative number.
@@ -80,23 +74,17 @@
          // If we don't have that event yet, we create a new one.
          // Otherwise we copy the information into the existing event anyway, because the data might have changed.
          pEvent = newEvent = new cEvent(SiEitEvent.getEventId());
-         if (!pEvent)
-            continue;
+         newEvent->SetStartTime(StartTime);
+         newEvent->SetDuration(Duration);
+         pSchedule->AddEvent(newEvent);
          }
       else {
          // We have found an existing event, either through its event ID or its start time.
          pEvent->SetSeen();
-         // If the existing event has a zero table ID it was defined externally and shall
-         // not be overwritten.
-         uchar TableID = pEvent->TableID();
-         if (TableID == 0x00) {
-            if (pEvent->Version() == getVersionNumber())
-               continue;
-            HasExternalData = ExternalData = true;
-            }
+         uchar TableID = max(pEvent->TableID(), uchar(0x4E)); // for backwards compatibility, table ids less than 0x4E are treated as if they were "present"
          // If the new event has a higher table ID, let's skip it.
          // The lower the table ID, the more "current" the information.
-         else if (Tid > TableID)
+         if (Tid > TableID)
             continue;
          // If the new event comes from the same table and has the same version number
          // as the existing one, let's skip it to avoid unnecessary work.
@@ -106,21 +94,20 @@
          // to the Sat.1/Pro7 transponder, events will keep toggling because of the bogus version numbers.
          else if (Tid == TableID && pEvent->Version() == getVersionNumber())
             continue;
+         EpgHandlers.SetEventID(pEvent, SiEitEvent.getEventId()); // unfortunately some stations use different event ids for the same event in different tables :-(
+         EpgHandlers.SetStartTime(pEvent, StartTime);
+         EpgHandlers.SetDuration(pEvent, Duration);
          }
-      if (!ExternalData) {
-         pEvent->SetEventID(SiEitEvent.getEventId()); // unfortunately some stations use different event ids for the same event in different tables :-(
+      if (pEvent->TableID() > 0x4E) // for backwards compatibility, table ids less than 0x4E are never overwritten
          pEvent->SetTableID(Tid);
-         pEvent->SetStartTime(StartTime);
-         pEvent->SetDuration(Duration);
-         }
-      if (newEvent)
-         pSchedule->AddEvent(newEvent);
       if (Tid == 0x4E) { // we trust only the present/following info on the actual TS
          if (SiEitEvent.getRunningStatus() >= SI::RunningStatusNotRunning)
             pSchedule->SetRunningStatus(pEvent, SiEitEvent.getRunningStatus(), channel);
          }
-      if (OnlyRunningStatus)
+      if (OnlyRunningStatus) {
+         pEvent->SetVersion(0xFF); // we have already changed the table id above, so set the version to an invalid value to make sure the next full run will be executed
          continue; // do this before setting the version, so that the full update can be done later
+         }
       pEvent->SetVersion(getVersionNumber());
 
       int LanguagePreferenceShort = -1;
@@ -132,10 +119,6 @@
       cLinkChannels *LinkChannels = NULL;
       cComponents *Components = NULL;
       for (SI::Loop::Iterator it2; (d = SiEitEvent.eventDescriptors.getNext(it2)); ) {
-          if (ExternalData && d->getDescriptorTag() != SI::ComponentDescriptorTag) {
-             delete d;
-             continue;
-             }
           switch (d->getDescriptorTag()) {
             case SI::ExtendedEventDescriptorTag: {
                  SI::ExtendedEventDescriptor *eed = (SI::ExtendedEventDescriptor *)d;
@@ -172,7 +155,7 @@
                         NumContents++;
                         }
                      }
-                 pEvent->SetContents(Contents);
+                 EpgHandlers.SetContents(pEvent, Contents);
                  }
                  break;
             case SI::ParentalRatingDescriptorTag: {
@@ -191,7 +174,7 @@
                           case 0x13:          ParentalRating = 16; break;
                           default:            ParentalRating = 0;
                           }
-                        pEvent->SetParentalRating(ParentalRating);
+                        EpgHandlers.SetParentalRating(pEvent, ParentalRating);
                         }
                      }
                  }
@@ -210,7 +193,7 @@
                  else if (month == 0 && t.tm_mon == 11) // current month is jan, but event is in dec
                     t.tm_year--;
                  time_t vps = mktime(&t);
-                 pEvent->SetVps(vps);
+                 EpgHandlers.SetVps(pEvent, vps);
                  }
                  break;
             case SI::TimeShiftedEventDescriptorTag: {
@@ -221,9 +204,9 @@
                  rEvent = (cEvent *)rSchedule->GetEvent(tsed->getReferenceEventId());
                  if (!rEvent)
                     break;
-                 pEvent->SetTitle(rEvent->Title());
-                 pEvent->SetShortText(rEvent->ShortText());
-                 pEvent->SetDescription(rEvent->Description());
+                 EpgHandlers.SetTitle(pEvent, rEvent->Title());
+                 EpgHandlers.SetShortText(pEvent, rEvent->ShortText());
+                 EpgHandlers.SetDescription(pEvent, rEvent->Description());
                  }
                  break;
             case SI::LinkageDescriptorTag: {
@@ -281,30 +264,30 @@
       if (!rEvent) {
          if (ShortEventDescriptor) {
             char buffer[Utf8BufSize(256)];
-            pEvent->SetTitle(ShortEventDescriptor->name.getText(buffer, sizeof(buffer)));
-            pEvent->SetShortText(ShortEventDescriptor->text.getText(buffer, sizeof(buffer)));
+            EpgHandlers.SetTitle(pEvent, ShortEventDescriptor->name.getText(buffer, sizeof(buffer)));
+            EpgHandlers.SetShortText(pEvent, ShortEventDescriptor->text.getText(buffer, sizeof(buffer)));
             }
-         else if (!HasExternalData) {
-            pEvent->SetTitle(NULL);
-            pEvent->SetShortText(NULL);
+         else {
+            EpgHandlers.SetTitle(pEvent, NULL);
+            EpgHandlers.SetShortText(pEvent, NULL);
             }
          if (ExtendedEventDescriptors) {
             char buffer[Utf8BufSize(ExtendedEventDescriptors->getMaximumTextLength(": ")) + 1];
-            pEvent->SetDescription(ExtendedEventDescriptors->getText(buffer, sizeof(buffer), ": "));
+            EpgHandlers.SetDescription(pEvent, ExtendedEventDescriptors->getText(buffer, sizeof(buffer), ": "));
             }
-         else if (!HasExternalData)
-            pEvent->SetDescription(NULL);
+         else
+            EpgHandlers.SetDescription(pEvent, NULL);
          }
       delete ExtendedEventDescriptors;
       delete ShortEventDescriptor;
 
       pEvent->SetComponents(Components);
 
-      if (!HasExternalData)
-         pEvent->FixEpgBugs();
+      EpgHandlers.FixEpgBugs(pEvent);
       if (LinkChannels)
          channel->SetLinkChannels(LinkChannels);
       Modified = true;
+      EpgHandlers.HandleEvent(pEvent);
       }
   if (Tid == 0x4E) {
      if (Empty && getSectionNumber() == 0)
@@ -315,9 +298,8 @@
   if (OnlyRunningStatus)
      return;
   if (Modified) {
-     pSchedule->Sort();
-     if (!HasExternalData)
-        pSchedule->DropOutdated(SegmentStart, SegmentEnd, Tid, getVersionNumber());
+     EpgHandlers.SortSchedule(pSchedule);
+     EpgHandlers.DropOutdated(pSchedule, SegmentStart, SegmentEnd, Tid, getVersionNumber());
      Schedules->SetModified(pSchedule);
      }
 }
diff -ruN vdr-1.7.25/eitscan.c vdr-1.7.26/eitscan.c
--- vdr-1.7.25/eitscan.c	2011-09-25 16:58:55.000000000 +0200
+++ vdr-1.7.26/eitscan.c	2012-03-07 14:54:34.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: eitscan.c 2.5 2011/09/25 14:58:55 kls Exp $
+ * $Id: eitscan.c 2.6 2012/03/07 13:54:34 kls Exp $
  */
 
 #include "eitscan.h"
@@ -92,7 +92,6 @@
 cEITScanner::cEITScanner(void)
 {
   lastScan = lastActivity = time(NULL);
-  currentDevice = NULL;
   currentChannel = 0;
   scanList = NULL;
   transponderList = NULL;
@@ -159,10 +158,8 @@
                                            Skins.Message(mtInfo, tr("Starting EPG scan"));
                                            }
                                         }
-                                     currentDevice = Device;//XXX see also dvbdevice.c!!!
                                      //dsyslog("EIT scan: device %d  source  %-8s tp %5d", Device->DeviceNumber() + 1, *cSource::ToString(Channel->Source()), Channel->Transponder());
                                      Device->SwitchChannel(Channel, false);
-                                     currentDevice = NULL;
                                      scanList->Del(ScanData);
                                      AnyDeviceSwitched = true;
                                      break;
diff -ruN vdr-1.7.25/eitscan.h vdr-1.7.26/eitscan.h
--- vdr-1.7.25/eitscan.h	2005-09-04 12:51:35.000000000 +0200
+++ vdr-1.7.26/eitscan.h	2012-03-07 14:54:16.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: eitscan.h 2.0 2005/09/04 10:51:35 kls Exp $
+ * $Id: eitscan.h 2.1 2012/03/07 13:54:16 kls Exp $
  */
 
 #ifndef __EITSCAN_H
@@ -24,7 +24,6 @@
          ScanTimeout = 20
        };
   time_t lastScan, lastActivity;
-  cDevice *currentDevice;
   int currentChannel;
   cScanList *scanList;
   cTransponderList *transponderList;
@@ -32,7 +31,6 @@
   cEITScanner(void);
   ~cEITScanner();
   bool Active(void) { return currentChannel || lastActivity == 0; }
-  bool UsesDevice(const cDevice *Device) { return currentDevice == Device; }
   void AddTransponder(cChannel *Channel);
   void ForceScan(void);
   void Activity(void);
diff -ruN vdr-1.7.25/epg.c vdr-1.7.26/epg.c
--- vdr-1.7.25/epg.c	2012-02-13 15:58:19.000000000 +0100
+++ vdr-1.7.26/epg.c	2012-03-10 14:14:27.000000000 +0100
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 2.11 2012/02/13 14:58:19 kls Exp $
+ * $Id: epg.c 2.12 2012/03/10 13:14:27 kls Exp $
  */
 
 #include "epg.h"
@@ -114,7 +114,7 @@
 {
   schedule = NULL;
   eventID = EventID;
-  tableID = 0;
+  tableID = 0xFF; // actual table ids are 0x4E..0x60
   version = 0xFF; // actual version numbers are 0..31
   runningStatus = SI::RunningStatusUndefined;
   title = NULL;
@@ -1296,3 +1296,153 @@
 {
   cSchedules::Read();
 }
+
+// --- cEpgHandler -----------------------------------------------------------
+
+cEpgHandler::cEpgHandler(void)
+{
+  EpgHandlers.Add(this);
+}
+
+cEpgHandler::~cEpgHandler()
+{
+  EpgHandlers.Del(this, false);
+}
+
+// --- cEpgHandlers ----------------------------------------------------------
+
+cEpgHandlers EpgHandlers;
+
+bool cEpgHandlers::IgnoreChannel(const cChannel *Channel)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->IgnoreChannel(Channel))
+         return true;
+      }
+  return false;
+}
+
+bool cEpgHandlers::HandleEitEvent(cSchedule *Schedule, const SI::EIT::Event *EitEvent, uchar TableID, uchar Version)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->HandleEitEvent(Schedule, EitEvent, TableID, Version))
+         return true;
+      }
+  return false;
+}
+
+void cEpgHandlers::SetEventID(cEvent *Event, tEventID EventID)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetEventID(Event, EventID))
+         return;
+      }
+  Event->SetEventID(EventID);
+}
+
+void cEpgHandlers::SetTitle(cEvent *Event, const char *Title)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetTitle(Event, Title))
+         return;
+      }
+  Event->SetTitle(Title);
+}
+
+void cEpgHandlers::SetShortText(cEvent *Event, const char *ShortText)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetShortText(Event, ShortText))
+         return;
+      }
+  Event->SetShortText(ShortText);
+}
+
+void cEpgHandlers::SetDescription(cEvent *Event, const char *Description)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetDescription(Event, Description))
+         return;
+      }
+  Event->SetDescription(Description);
+}
+
+void cEpgHandlers::SetContents(cEvent *Event, uchar *Contents)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetContents(Event, Contents))
+         return;
+      }
+  Event->SetContents(Contents);
+}
+
+void cEpgHandlers::SetParentalRating(cEvent *Event, int ParentalRating)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetParentalRating(Event, ParentalRating))
+         return;
+      }
+  Event->SetParentalRating(ParentalRating);
+}
+
+void cEpgHandlers::SetStartTime(cEvent *Event, time_t StartTime)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetStartTime(Event, StartTime))
+         return;
+      }
+  Event->SetStartTime(StartTime);
+}
+
+void cEpgHandlers::SetDuration(cEvent *Event, int Duration)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetDuration(Event, Duration))
+         return;
+      }
+  Event->SetDuration(Duration);
+}
+
+void cEpgHandlers::SetVps(cEvent *Event, time_t Vps)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetVps(Event, Vps))
+         return;
+      }
+  Event->SetVps(Vps);
+}
+
+void cEpgHandlers::FixEpgBugs(cEvent *Event)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->FixEpgBugs(Event))
+         return;
+      }
+  Event->FixEpgBugs();
+}
+
+void cEpgHandlers::HandleEvent(cEvent *Event)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->HandleEvent(Event))
+         break;
+      }
+}
+
+void cEpgHandlers::SortSchedule(cSchedule *Schedule)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SortSchedule(Schedule))
+         return;
+      }
+  Schedule->Sort();
+}
+
+void cEpgHandlers::DropOutdated(cSchedule *Schedule, time_t SegmentStart, time_t SegmentEnd, uchar TableID, uchar Version)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->DropOutdated(Schedule, SegmentStart, SegmentEnd, TableID, Version))
+         return;
+      }
+  Schedule->DropOutdated(SegmentStart, SegmentEnd, TableID, Version);
+}
diff -ruN vdr-1.7.25/epg.h vdr-1.7.26/epg.h
--- vdr-1.7.25/epg.h	2012-02-26 14:58:26.000000000 +0100
+++ vdr-1.7.26/epg.h	2012-03-10 14:50:10.000000000 +0100
@@ -7,13 +7,14 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.h 2.7 2012/02/26 13:58:26 kls Exp $
+ * $Id: epg.h 2.8 2012/03/10 13:50:10 kls Exp $
  */
 
 #ifndef __EPG_H
 #define __EPG_H
 
 #include "channels.h"
+#include "libsi/section.h"
 #include "thread.h"
 #include "tools.h"
 
@@ -221,4 +222,68 @@
 
 void ReportEpgBugFixStats(bool Reset = false);
 
+class cEpgHandler : public cListObject {
+public:
+  cEpgHandler(void);
+          ///< Constructs a new EPG handler and adds it to the list of EPG handlers.
+          ///< Whenever an event is received from the EIT data stream, the EPG
+          ///< handlers are queried in the order they have been created.
+          ///< As soon as one of the EPG handlers returns true in a member function,
+          ///< none of the remaining handlers will be queried. If none of the EPG
+          ///< handlers returns true in a particular call, the default processing
+          ///< will take place.
+          ///< EPG handlers will be deleted automatically at the end of the program.
+  virtual ~cEpgHandler();
+  virtual bool IgnoreChannel(const cChannel *Channel) { return false; }
+          ///< Before any EIT data for the given Channel is processed, the EPG handlers
+          ///< are asked whether this Channel shall be completely ignored. If any of
+          ///< the EPG handlers returns true in this function, no EIT data at all will
+          ///< be processed for this Channel.
+  virtual bool HandleEitEvent(cSchedule *Schedule, const SI::EIT::Event *EitEvent, uchar TableID, uchar Version) { return false; }
+          ///< Before the raw EitEvent for the given Schedule is processed, the
+          ///< EPG handlers are queried to see if any of them would like to do the
+          ///< complete processing by itself. TableID and Version are from the
+          ///< incoming section data.
+  virtual bool SetEventID(cEvent *Event, tEventID EventID) { return false; }
+  virtual bool SetTitle(cEvent *Event, const char *Title) { return false; }
+  virtual bool SetShortText(cEvent *Event, const char *ShortText) { return false; }
+  virtual bool SetDescription(cEvent *Event, const char *Description) { return false; }
+  virtual bool SetContents(cEvent *Event, uchar *Contents) { return false; }
+  virtual bool SetParentalRating(cEvent *Event, int ParentalRating) { return false; }
+  virtual bool SetStartTime(cEvent *Event, time_t StartTime) { return false; }
+  virtual bool SetDuration(cEvent *Event, int Duration) { return false; }
+  virtual bool SetVps(cEvent *Event, time_t Vps) { return false; }
+  virtual bool FixEpgBugs(cEvent *Event) { return false; }
+          ///< Fixes some known problems with EPG data.
+  virtual bool HandleEvent(cEvent *Event) { return false; }
+          ///< After all modifications of the Event have been done, the EPG handler
+          ///< can take a final look at it.
+  virtual bool SortSchedule(cSchedule *Schedule) { return false; }
+          ///< Sorts the Schedule after the complete table has been processed.
+  virtual bool DropOutdated(cSchedule *Schedule, time_t SegmentStart, time_t SegmentEnd, uchar TableID, uchar Version) { return false; }
+          ///< Takes a look at all EPG events between SegmentStart and SegmentEnd and
+          ///< drops outdated events.
+  };
+
+class cEpgHandlers : public cList<cEpgHandler> {
+public:
+  bool IgnoreChannel(const cChannel *Channel);
+  bool HandleEitEvent(cSchedule *Schedule, const SI::EIT::Event *EitEvent, uchar TableID, uchar Version);
+  void SetEventID(cEvent *Event, tEventID EventID);
+  void SetTitle(cEvent *Event, const char *Title);
+  void SetShortText(cEvent *Event, const char *ShortText);
+  void SetDescription(cEvent *Event, const char *Description);
+  void SetContents(cEvent *Event, uchar *Contents);
+  void SetParentalRating(cEvent *Event, int ParentalRating);
+  void SetStartTime(cEvent *Event, time_t StartTime);
+  void SetDuration(cEvent *Event, int Duration);
+  void SetVps(cEvent *Event, time_t Vps);
+  void FixEpgBugs(cEvent *Event);
+  void HandleEvent(cEvent *Event);
+  void SortSchedule(cSchedule *Schedule);
+  void DropOutdated(cSchedule *Schedule, time_t SegmentStart, time_t SegmentEnd, uchar TableID, uchar Version);
+  };
+
+extern cEpgHandlers EpgHandlers;
+
 #endif //__EPG_H
diff -ruN vdr-1.7.25/menu.c vdr-1.7.26/menu.c
--- vdr-1.7.25/menu.c	2012-03-02 11:33:17.000000000 +0100
+++ vdr-1.7.26/menu.c	2012-03-08 14:32:44.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 2.39 2012/03/02 10:33:17 kls Exp $
+ * $Id: menu.c 2.42 2012/03/08 13:32:44 kls Exp $
  */
 
 #include "menu.h"
@@ -903,7 +903,7 @@
 :cOsdMenu(tr("Edit timer"), 12)
 {
   file = NULL;
-  firstday = NULL;
+  day = firstday = NULL;
   timer = Timer;
   addIfConfirmed = New;
   if (timer) {
@@ -913,7 +913,7 @@
      channel = data.Channel()->Number();
      Add(new cMenuEditBitItem( tr("Active"),       &data.flags, tfActive));
      Add(new cMenuEditChanItem(tr("Channel"),      &channel));
-     Add(new cMenuEditDateItem(tr("Day"),          &data.day, &data.weekdays));
+     Add(day = new cMenuEditDateItem(tr("Day"),    &data.day, &data.weekdays));
      Add(new cMenuEditTimeItem(tr("Start"),        &data.start));
      Add(new cMenuEditTimeItem(tr("Stop"),         &data.stop));
      Add(new cMenuEditBitItem( tr("VPS"),          &data.flags, tfVps));
@@ -935,7 +935,7 @@
 
 void cMenuEditTimer::SetHelpKeys(void)
 {
-  SetHelp(tr("Button$Folder"));
+  SetHelp(tr("Button$Folder"), data.weekdays ? tr("Button$Once") : tr("Button$Repeating"));
 }
 
 void cMenuEditTimer::SetFirstDayItem(void)
@@ -1001,7 +1001,14 @@
                      }
                      return osBack;
        case kRed:    return AddSubMenu(new cMenuFolder(tr("Select folder"), &Folders, data.file));
-       case kGreen:
+       case kGreen:  if (day) {
+                        day->ToggleRepeating();
+                        SetCurrent(day);
+                        SetFirstDayItem();
+                        SetHelpKeys();
+                        Display();
+                        }
+                     return osContinue;
        case kYellow:
        case kBlue:   return osContinue;
        default: break;
@@ -4513,6 +4520,8 @@
      shown = ShowProgress(true);
      timeoutShow = (shown && Seconds > 0) ? time(NULL) + Seconds : 0;
      }
+  else if (timeoutShow && Seconds > 0)
+     timeoutShow = time(NULL) + Seconds;
 }
 
 void cReplayControl::Show(void)
@@ -4531,6 +4540,7 @@
      lastPlay = lastForward = false;
      lastSpeed = -2; // an invalid value
      timeSearchActive = false;
+     timeoutShow = 0;
      }
 }
 
@@ -4694,12 +4704,12 @@
         marks.Del(m);
      else {
         marks.Add(Current);
-        ShowTimed(2);
         bool Play, Forward;
         int Speed;
         if (GetReplayMode(Play, Forward, Speed) && !Play)
            Goto(Current, true);
         }
+     ShowTimed(2);
      marks.Save();
      }
 }
diff -ruN vdr-1.7.25/menu.h vdr-1.7.26/menu.h
--- vdr-1.7.25/menu.h	2012-02-19 11:51:56.000000000 +0100
+++ vdr-1.7.26/menu.h	2012-03-08 14:11:40.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.h 2.4 2012/02/19 10:51:56 kls Exp $
+ * $Id: menu.h 2.5 2012/03/08 13:11:40 kls Exp $
  */
 
 #ifndef __MENU_H
@@ -76,6 +76,7 @@
   int channel;
   bool addIfConfirmed;
   cMenuEditStrItem *file;
+  cMenuEditDateItem *day;
   cMenuEditDateItem *firstday;
   eOSState SetFolder(void);
   void SetFirstDayItem(void);
diff -ruN vdr-1.7.25/menuitems.c vdr-1.7.26/menuitems.c
--- vdr-1.7.25/menuitems.c	2012-03-02 16:49:57.000000000 +0100
+++ vdr-1.7.26/menuitems.c	2012-03-08 14:22:22.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 2.11 2012/03/02 15:49:57 kls Exp $
+ * $Id: menuitems.c 2.12 2012/03/08 13:22:22 kls Exp $
  */
 
 #include "menuitems.h"
@@ -886,6 +886,24 @@
   SetValue(buf);
 }
 
+void cMenuEditDateItem::ToggleRepeating(void)
+{
+  if (weekdays) {
+     if (*weekdays) {
+        *value = cTimer::SetTime(oldvalue ? oldvalue : time(NULL), 0);
+        oldvalue = 0;
+        *weekdays = 0;
+        }
+     else {
+        *weekdays = days[cTimer::GetWDay(*value)];
+        dayindex = FindDayIndex(*weekdays);
+        oldvalue = *value;
+        *value = 0;
+        }
+     Set();
+     }
+}
+
 eOSState cMenuEditDateItem::ProcessKey(eKeys Key)
 {
   eOSState state = cMenuEditItem::ProcessKey(Key);
@@ -937,17 +955,8 @@
      else if (weekdays) {
         if (Key == k0) {
            // Toggle between weekdays and single day:
-           if (*weekdays) {
-              *value = cTimer::SetTime(oldvalue ? oldvalue : now, 0);
-              oldvalue = 0;
-              *weekdays = 0;
-              }
-           else {
-              *weekdays = days[cTimer::GetWDay(*value)];
-              dayindex = FindDayIndex(*weekdays);
-              oldvalue = *value;
-              *value = 0;
-              }
+           ToggleRepeating();
+           return osContinue; // ToggleRepeating) has already called Set()
            }
         else if (k1 <= Key && Key <= k7) {
            // Toggle individual weekdays:
diff -ruN vdr-1.7.25/menuitems.h vdr-1.7.26/menuitems.h
--- vdr-1.7.25/menuitems.h	2012-03-02 16:49:57.000000000 +0100
+++ vdr-1.7.26/menuitems.h	2012-03-08 13:38:46.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.h 2.6 2012/03/02 15:49:57 kls Exp $
+ * $Id: menuitems.h 2.7 2012/03/08 12:38:46 kls Exp $
  */
 
 #ifndef __MENUITEMS_H
@@ -168,6 +168,7 @@
   virtual void Set(void);
 public:
   cMenuEditDateItem(const char *Name, time_t *Value, int *WeekDays = NULL);
+  void ToggleRepeating(void);
   virtual eOSState ProcessKey(eKeys Key);
   };
 
diff -ruN vdr-1.7.25/osd.c vdr-1.7.26/osd.c
--- vdr-1.7.25/osd.c	2012-03-02 11:48:19.000000000 +0100
+++ vdr-1.7.26/osd.c	2012-03-05 11:28:01.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 2.25 2012/03/02 10:48:19 kls Exp $
+ * $Id: osd.c 2.27 2012/03/05 10:28:01 kls Exp $
  */
 
 #include "osd.h"
@@ -254,6 +254,7 @@
   bitmap = NULL;
   x0 = X0;
   y0 = Y0;
+  width = height = 0;
   SetSize(Width, Height);
 }
 
@@ -262,6 +263,7 @@
   bitmap = NULL;
   x0 = 0;
   y0 = 0;
+  width = height = 0;
   LoadXpm(FileName);
 }
 
@@ -270,6 +272,7 @@
   bitmap = NULL;
   x0 = 0;
   y0 = 0;
+  width = height = 0;
   SetXpm(Xpm);
 }
 
@@ -1701,11 +1704,13 @@
 
 cPixmap *cOsd::AddPixmap(cPixmap *Pixmap)
 {
-  LOCK_PIXMAPS;
-  if (numPixmaps < MAXOSDPIXMAPS)
-     return pixmaps[numPixmaps++] = Pixmap;
-  else
-     esyslog("ERROR: too many OSD pixmaps requested (maximum is %d)", MAXOSDPIXMAPS);
+  if (Pixmap) {
+     LOCK_PIXMAPS;
+     if (numPixmaps < MAXOSDPIXMAPS)
+        return pixmaps[numPixmaps++] = Pixmap;
+     else
+        esyslog("ERROR: too many OSD pixmaps requested (maximum is %d)", MAXOSDPIXMAPS);
+     }
   return NULL;
 }
 
diff -ruN vdr-1.7.25/po/ar.po vdr-1.7.26/po/ar.po
--- vdr-1.7.25/po/ar.po	2012-02-25 14:37:49.000000000 +0100
+++ vdr-1.7.26/po/ar.po	2012-03-08 14:37:16.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.7.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-10-16 11:16-0400\n"
 "Last-Translator: Osama Alrawab <alrawab@hotmail.com>\n"
 "Language-Team: Arabic <ar@li.org>\n"
@@ -660,6 +660,12 @@
 msgid "Button$Folder"
 msgstr "الموءقت"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "اليوم الاول"
 
diff -ruN vdr-1.7.25/po/ca_ES.po vdr-1.7.26/po/ca_ES.po
--- vdr-1.7.25/po/ca_ES.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/ca_ES.po	2012-03-08 14:37:15.000000000 +0100
@@ -10,7 +10,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-03-02 19:02+0100\n"
 "Last-Translator: Luca Olivetti <luca@ventoso.org>\n"
 "Language-Team: Catalan <vdr@linuxtv.org>\n"
@@ -651,6 +651,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Primer dia"
 
diff -ruN vdr-1.7.25/po/cs_CZ.po vdr-1.7.26/po/cs_CZ.po
--- vdr-1.7.25/po/cs_CZ.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/cs_CZ.po	2012-03-08 14:37:15.000000000 +0100
@@ -9,7 +9,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.7.14\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2010-05-06 11:00+0200\n"
 "Last-Translator: Radek Šťastný <dedkus@gmail.com>\n"
 "Language-Team: Czech <vdr@linuxtv.org>\n"
@@ -650,6 +650,12 @@
 msgid "Button$Folder"
 msgstr "Složka"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "První den"
 
diff -ruN vdr-1.7.25/po/da_DK.po vdr-1.7.26/po/da_DK.po
--- vdr-1.7.25/po/da_DK.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/da_DK.po	2012-03-08 14:37:15.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2007-08-12 14:17+0200\n"
 "Last-Translator: Mogens Elneff <mogens@elneff.dk>\n"
 "Language-Team: Danish <vdr@linuxtv.org>\n"
@@ -648,6 +648,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Frste dag"
 
diff -ruN vdr-1.7.25/po/de_DE.po vdr-1.7.26/po/de_DE.po
--- vdr-1.7.25/po/de_DE.po	2012-02-25 14:37:49.000000000 +0100
+++ vdr-1.7.26/po/de_DE.po	2012-03-08 14:37:52.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2010-01-16 16:46+0100\n"
 "Last-Translator: Klaus Schmidinger <kls@tvdr.de>\n"
 "Language-Team: German <vdr@linuxtv.org>\n"
@@ -648,6 +648,12 @@
 msgid "Button$Folder"
 msgstr "Verzeichnis"
 
+msgid "Button$Once"
+msgstr "Einmalig"
+
+msgid "Button$Repeating"
+msgstr "Wiederholend"
+
 msgid "First day"
 msgstr "Erster Tag"
 
@@ -1334,4 +1340,4 @@
 
 #, c-format
 msgid "VDR will shut down in %s minutes"
-msgstr "VDR wird in %s Minuten ausschalten"
+msgstr "VDR wird in %s Minuten abgeschaltet"
diff -ruN vdr-1.7.25/po/el_GR.po vdr-1.7.26/po/el_GR.po
--- vdr-1.7.25/po/el_GR.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/el_GR.po	2012-03-08 14:37:16.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2007-08-12 14:17+0200\n"
 "Last-Translator: Dimitrios Dimitrakos <mail@dimitrios.de>\n"
 "Language-Team: Greek <vdr@linuxtv.org>\n"
@@ -648,6 +648,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr " "
 
diff -ruN vdr-1.7.25/po/es_ES.po vdr-1.7.26/po/es_ES.po
--- vdr-1.7.25/po/es_ES.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/es_ES.po	2012-03-08 14:37:15.000000000 +0100
@@ -8,7 +8,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-03-02 19:02+0100\n"
 "Last-Translator: Luca Olivetti <luca@ventoso.org>\n"
 "Language-Team: Spanish <vdr@linuxtv.org>\n"
@@ -649,6 +649,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Primer da"
 
diff -ruN vdr-1.7.25/po/et_EE.po vdr-1.7.26/po/et_EE.po
--- vdr-1.7.25/po/et_EE.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/et_EE.po	2012-03-08 14:37:15.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2007-08-12 14:17+0200\n"
 "Last-Translator: Arthur Konovalov <artlov@gmail.com>\n"
 "Language-Team: Estonian <vdr@linuxtv.org>\n"
@@ -648,6 +648,12 @@
 msgid "Button$Folder"
 msgstr "Kaust"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Esimene päev"
 
diff -ruN vdr-1.7.25/po/fi_FI.po vdr-1.7.26/po/fi_FI.po
--- vdr-1.7.25/po/fi_FI.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/fi_FI.po	2012-03-08 14:37:15.000000000 +0100
@@ -10,7 +10,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2007-08-15 15:52+0200\n"
 "Last-Translator: Rolf Ahrenberg <rahrenbe@cc.hut.fi>\n"
 "Language-Team: Finnish <vdr@linuxtv.org>\n"
@@ -651,6 +651,12 @@
 msgid "Button$Folder"
 msgstr "Kansio"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "1. päivä"
 
diff -ruN vdr-1.7.25/po/fr_FR.po vdr-1.7.26/po/fr_FR.po
--- vdr-1.7.25/po/fr_FR.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/fr_FR.po	2012-03-08 14:37:16.000000000 +0100
@@ -13,7 +13,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-02-27 18:14+0100\n"
 "Last-Translator: Jean-Claude Repetto <jc@repetto.org>\n"
 "Language-Team: French <vdr@linuxtv.org>\n"
@@ -654,6 +654,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Premier jour"
 
diff -ruN vdr-1.7.25/po/hr_HR.po vdr-1.7.26/po/hr_HR.po
--- vdr-1.7.25/po/hr_HR.po	2012-02-25 14:37:49.000000000 +0100
+++ vdr-1.7.26/po/hr_HR.po	2012-03-08 14:37:16.000000000 +0100
@@ -9,7 +9,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-03-17 19:00+0100\n"
 "Last-Translator: Adrian Caval <anrxc@sysphere.org>\n"
 "Language-Team: Croatian <vdr@linuxtv.org>\n"
@@ -650,6 +650,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Prvi dan"
 
diff -ruN vdr-1.7.25/po/hu_HU.po vdr-1.7.26/po/hu_HU.po
--- vdr-1.7.25/po/hu_HU.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/hu_HU.po	2012-03-08 14:37:15.000000000 +0100
@@ -10,7 +10,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2012-01-02 11:54+0200\n"
 "Last-Translator: Istvn Fley <ifuley@tigercomp.ro>\n"
 "Language-Team: Hungarian <vdr@linuxtv.org>\n"
@@ -651,6 +651,12 @@
 msgid "Button$Folder"
 msgstr "Knyvtr"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Els nap"
 
diff -ruN vdr-1.7.25/po/it_IT.po vdr-1.7.26/po/it_IT.po
--- vdr-1.7.25/po/it_IT.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/it_IT.po	2012-03-08 14:37:15.000000000 +0100
@@ -11,7 +11,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2012-01-15 19:11+0100\n"
 "Last-Translator: Diego Pierotto <vdr-italian@tiscali.it>\n"
 "Language-Team: Italian <vdr@linuxtv.org>\n"
@@ -655,6 +655,12 @@
 msgid "Button$Folder"
 msgstr "Cartella"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "1° giorno"
 
diff -ruN vdr-1.7.25/po/lt_LT.po vdr-1.7.26/po/lt_LT.po
--- vdr-1.7.25/po/lt_LT.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/lt_LT.po	2012-03-08 14:37:16.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.7.16\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2010-10-30 11:55+0200\n"
 "Last-Translator: Valdemaras Pipiras <varas@ambernet.lt>\n"
 "Language-Team: Lithuanian <vdr@linuxtv.org>\n"
@@ -648,6 +648,12 @@
 msgid "Button$Folder"
 msgstr "Katalogas"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Pirma diena"
 
diff -ruN vdr-1.7.25/po/mk_MK.po vdr-1.7.26/po/mk_MK.po
--- vdr-1.7.25/po/mk_MK.po	2012-02-25 14:37:49.000000000 +0100
+++ vdr-1.7.26/po/mk_MK.po	2012-03-08 14:37:16.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR-1.7.14\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2010-03-11 00:54+0100\n"
 "Last-Translator: Dimitar Petrovski <dimeptr@gmail.com>\n"
 "Language-Team: Macedonian <en@li.org>\n"
@@ -649,6 +649,12 @@
 msgid "Button$Folder"
 msgstr "Директориум"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Прв ден"
 
diff -ruN vdr-1.7.25/po/nl_NL.po vdr-1.7.26/po/nl_NL.po
--- vdr-1.7.25/po/nl_NL.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/nl_NL.po	2012-03-08 14:37:15.000000000 +0100
@@ -11,7 +11,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-02-26 17:20+0100\n"
 "Last-Translator: Johan Schuring <johan.schuring@vetteblei.nl>\n"
 "Language-Team: Dutch <vdr@linuxtv.org>\n"
@@ -652,6 +652,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Eerste dag"
 
diff -ruN vdr-1.7.25/po/nn_NO.po vdr-1.7.26/po/nn_NO.po
--- vdr-1.7.25/po/nn_NO.po	2012-02-25 14:37:49.000000000 +0100
+++ vdr-1.7.26/po/nn_NO.po	2012-03-08 14:37:16.000000000 +0100
@@ -8,7 +8,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2007-08-12 14:17+0200\n"
 "Last-Translator: Truls Slevigen <truls@slevigen.no>\n"
 "Language-Team: Norwegian Nynorsk <vdr@linuxtv.org>\n"
@@ -649,6 +649,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Frste dag"
 
diff -ruN vdr-1.7.25/po/pl_PL.po vdr-1.7.26/po/pl_PL.po
--- vdr-1.7.25/po/pl_PL.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/pl_PL.po	2012-03-08 14:37:14.000000000 +0100
@@ -8,7 +8,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-03-09 12:59+0100\n"
 "Last-Translator: Michael Rakowski <mrak@gmx.de>\n"
 "Language-Team: Polish <vdr@linuxtv.org>\n"
@@ -649,6 +649,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Pierwszy dzie"
 
diff -ruN vdr-1.7.25/po/pt_PT.po vdr-1.7.26/po/pt_PT.po
--- vdr-1.7.25/po/pt_PT.po	2012-02-25 14:37:47.000000000 +0100
+++ vdr-1.7.26/po/pt_PT.po	2012-03-08 14:37:14.000000000 +0100
@@ -8,7 +8,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.7.15\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2010-03-28 22:49+0100\n"
 "Last-Translator: Cris Silva <hudokkow@gmail.com>\n"
 "Language-Team: Portuguese <vdr@linuxtv.org>\n"
@@ -649,6 +649,12 @@
 msgid "Button$Folder"
 msgstr "Pasta"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "1 dia"
 
diff -ruN vdr-1.7.25/po/ro_RO.po vdr-1.7.26/po/ro_RO.po
--- vdr-1.7.25/po/ro_RO.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/ro_RO.po	2012-03-08 14:37:15.000000000 +0100
@@ -8,7 +8,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.7.12\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2011-03-10 23:52+0100\n"
 "Last-Translator: Lucian Muresan <lucianm@users.sourceforge.net>\n"
 "Language-Team: Romanian <vdr@linuxtv.org>\n"
@@ -651,6 +651,12 @@
 msgid "Button$Folder"
 msgstr "Director"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Prima zi"
 
diff -ruN vdr-1.7.25/po/ru_RU.po vdr-1.7.26/po/ru_RU.po
--- vdr-1.7.25/po/ru_RU.po	2012-02-25 14:37:49.000000000 +0100
+++ vdr-1.7.26/po/ru_RU.po	2012-03-08 14:37:16.000000000 +0100
@@ -8,7 +8,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-12-15 14:37+0100\n"
 "Last-Translator: Oleg Roitburd <oleg@roitburd.de>\n"
 "Language-Team: Russian <vdr@linuxtv.org>\n"
@@ -649,6 +649,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr " "
 
diff -ruN vdr-1.7.25/po/sk_SK.po vdr-1.7.26/po/sk_SK.po
--- vdr-1.7.25/po/sk_SK.po	2012-02-25 14:37:49.000000000 +0100
+++ vdr-1.7.26/po/sk_SK.po	2012-03-08 14:37:16.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.7.16\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2011-02-15 16:29+0100\n"
 "Last-Translator: Milan Hrala <hrala.milan@gmail.com>\n"
 "Language-Team: Slovak <vdr@linuxtv.org>\n"
@@ -648,6 +648,12 @@
 msgid "Button$Folder"
 msgstr "Zloka"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Prv de"
 
diff -ruN vdr-1.7.25/po/sl_SI.po vdr-1.7.26/po/sl_SI.po
--- vdr-1.7.25/po/sl_SI.po	2012-02-25 14:37:49.000000000 +0100
+++ vdr-1.7.26/po/sl_SI.po	2012-03-08 14:37:16.000000000 +0100
@@ -8,7 +8,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-02-28 19:44+0100\n"
 "Last-Translator: Matjaz Thaler <matjaz.thaler@guest.arnes.si>\n"
 "Language-Team: Slovenian <vdr@linuxtv.org>\n"
@@ -649,6 +649,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Prvi dan"
 
diff -ruN vdr-1.7.25/po/sr_SR.po vdr-1.7.26/po/sr_SR.po
--- vdr-1.7.25/po/sr_SR.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/sr_SR.po	2012-03-08 14:37:16.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.7.1\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2011-01-09 15:57+0100\n"
 "Last-Translator: Milan Cvijanovi <elcom_cvijo@hotmail.com>\n"
 "Language-Team: Serbian <vdr@linuxtv.org>\n"
@@ -654,6 +654,12 @@
 msgid "Button$Folder"
 msgstr "Taster$Direktorij"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Prvi dan"
 
diff -ruN vdr-1.7.25/po/sv_SE.po vdr-1.7.26/po/sv_SE.po
--- vdr-1.7.25/po/sv_SE.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/sv_SE.po	2012-03-08 14:37:16.000000000 +0100
@@ -10,7 +10,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-03-12 18:25+0100\n"
 "Last-Translator: Magnus Andersson <svankan@bahnhof.se>\n"
 "Language-Team: Swedish <vdr@linuxtv.org>\n"
@@ -651,6 +651,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Frsta dag"
 
diff -ruN vdr-1.7.25/po/tr_TR.po vdr-1.7.26/po/tr_TR.po
--- vdr-1.7.25/po/tr_TR.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/tr_TR.po	2012-03-08 14:37:15.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2008-02-28 00:33+0100\n"
 "Last-Translator: Oktay Yolgeen <oktay_73@yahoo.de>\n"
 "Language-Team: Turkish <vdr@linuxtv.org>\n"
@@ -648,6 +648,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "lk gn"
 
diff -ruN vdr-1.7.25/po/uk_UA.po vdr-1.7.26/po/uk_UA.po
--- vdr-1.7.25/po/uk_UA.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/uk_UA.po	2012-03-08 14:37:15.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.7.7\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2010-04-25 16:35+0200\n"
 "Last-Translator: Yarema aka Knedlyk <yupadmin@gmail.com>\n"
 "Language-Team: Ukrainian <vdr@linuxtv.org>\n"
@@ -648,6 +648,12 @@
 msgid "Button$Folder"
 msgstr "Каталог"
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "Перший день"
 
diff -ruN vdr-1.7.25/po/zh_CN.po vdr-1.7.26/po/zh_CN.po
--- vdr-1.7.25/po/zh_CN.po	2012-02-25 14:37:48.000000000 +0100
+++ vdr-1.7.26/po/zh_CN.po	2012-03-08 14:37:15.000000000 +0100
@@ -7,7 +7,7 @@
 msgstr ""
 "Project-Id-Version: VDR 1.6.0\n"
 "Report-Msgid-Bugs-To: <vdr-bugs@tvdr.de>\n"
-"POT-Creation-Date: 2012-02-25 14:32+0100\n"
+"POT-Creation-Date: 2012-03-08 14:37+0100\n"
 "PO-Revision-Date: 2009-09-23 23:50+0800\n"
 "Last-Translator: Nan Feng <nfgx@21cn.com>\n"
 "Language-Team: Chinese (simplified) <vdr@linuxtv.org>\n"
@@ -651,6 +651,12 @@
 msgid "Button$Folder"
 msgstr ""
 
+msgid "Button$Once"
+msgstr ""
+
+msgid "Button$Repeating"
+msgstr ""
+
 msgid "First day"
 msgstr "第一天"
 
diff -ruN vdr-1.7.25/skinsttng.c vdr-1.7.26/skinsttng.c
--- vdr-1.7.25/skinsttng.c	2011-08-21 13:02:26.000000000 +0200
+++ vdr-1.7.26/skinsttng.c	2012-03-05 13:01:26.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinsttng.c 2.11 2011/08/21 11:02:26 kls Exp $
+ * $Id: skinsttng.c 2.13 2012/03/05 12:01:26 kls Exp $
  */
 
 // Star Trek: The Next Generation is a registered trademark of Paramount Pictures
@@ -284,7 +284,7 @@
         }
      }
   osd->DrawText(x3 + TextFrame, y0, ChannelString(Channel, Number), Theme.Color(clrChannelName), frameColor, cFont::GetFont(fontOsd), x - x3 - TextFrame);
-  lastSignalDisplay = time(NULL); // don't get slowed down during heavy zapping
+  lastSignalDisplay = 0;
 }
 
 void cSkinSTTNGDisplayChannel::SetEvents(const cEvent *Present, const cEvent *Following)
@@ -341,8 +341,8 @@
            osd->DrawText(x3 + TextFrame, y6, Track ? Track->description : "", Theme.Color(clrChannelName), frameColor, font, x4 - x3 - w - 2 * TextFrame);
            strn0cpy(lastTrackId.description, Track ? Track->description : "", sizeof(lastTrackId.description));
            }
-        if (time(NULL) != lastSignalDisplay) {
-           int DeviceNumber = cDevice::ActualDevice()->DeviceNumber() + 1;
+        int DeviceNumber = cDevice::ActualDevice()->DeviceNumber() + 1;
+        if (DeviceNumber != lastDeviceNumber || time(NULL) != lastSignalDisplay) {
            int SignalStrength = cDevice::ActualDevice()->SignalStrength();
            int SignalQuality = cDevice::ActualDevice()->SignalQuality();
            if (DeviceNumber != lastDeviceNumber || SignalStrength != lastSignalStrength || SignalQuality != lastSignalQuality) {
@@ -783,9 +783,6 @@
   virtual void Flush(void);
   };
 
-#define SymbolWidth 30
-#define SymbolHeight 30
-
 cSkinSTTNGDisplayReplay::cSkinSTTNGDisplayReplay(bool ModeOnly)
 {
   const cFont *font = cFont::GetFont(fontSml);
@@ -794,7 +791,7 @@
   lastCurrentWidth = 0;
   cBitmap bm(play_xpm);
   x0 = 0;
-  x1 = max(SymbolWidth, bm.Width());
+  x1 = max(lineHeight * 2, bm.Width());
   x2 = x1 + Roundness;
   x3 = x2 + Gap;
   x7 = cOsd::OsdWidth();
@@ -805,7 +802,7 @@
   y1 = lineHeight;
   y2 = y1 + Roundness;
   y3 = y2 + Gap;
-  y4 = y3 + max(SymbolHeight, bm.Height());
+  y4 = y3 + max(lineHeight, bm.Height());
   y5 = y4 + Gap;
   y6 = y5 + Roundness;
   y7 = y6 + font->Height();
@@ -867,10 +864,7 @@
 
 void cSkinSTTNGDisplayReplay::SetMode(bool Play, bool Forward, int Speed)
 {
-  if (Speed < -1)
-     Speed = -1;
-  if (Speed > 3)
-     Speed = 3;
+  Speed = constrain(Speed, -1, 3);
   cBitmap bm(ReplaySymbols[Play][Forward][Speed + 1]);
   osd->DrawBitmap(x0 + (x1 - x0 - bm.Width()) / 2, y3 + (y4 - y3 - bm.Height()) / 2, bm, Theme.Color(clrReplayMode), frameColor);
 }
diff -ruN vdr-1.7.25/status.c vdr-1.7.26/status.c
--- vdr-1.7.25/status.c	2008-02-16 15:46:31.000000000 +0100
+++ vdr-1.7.26/status.c	2012-03-07 15:17:24.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: status.c 2.0 2008/02/16 14:46:31 kls Exp $
+ * $Id: status.c 2.1 2012/03/07 14:17:24 kls Exp $
  */
 
 #include "status.h"
@@ -29,10 +29,10 @@
       sm->TimerChange(Timer, Change);
 }
 
-void cStatus::MsgChannelSwitch(const cDevice *Device, int ChannelNumber)
+void cStatus::MsgChannelSwitch(const cDevice *Device, int ChannelNumber, bool LiveView)
 {
   for (cStatus *sm = statusMonitors.First(); sm; sm = statusMonitors.Next(sm))
-      sm->ChannelSwitch(Device, ChannelNumber);
+      sm->ChannelSwitch(Device, ChannelNumber, LiveView);
 }
 
 void cStatus::MsgRecording(const cDevice *Device, const char *Name, const char *FileName, bool On)
diff -ruN vdr-1.7.25/status.h vdr-1.7.26/status.h
--- vdr-1.7.25/status.h	2008-02-16 16:00:33.000000000 +0100
+++ vdr-1.7.26/status.h	2012-03-07 15:16:57.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: status.h 2.0 2008/02/16 15:00:33 kls Exp $
+ * $Id: status.h 2.1 2012/03/07 14:16:57 kls Exp $
  */
 
 #ifndef __STATUS_H
@@ -30,10 +30,11 @@
                // been added or will be deleted, respectively. In case of tcMod,
                // Timer is NULL; this indicates that some timer has been changed.
                // Note that tcAdd and tcDel are always also followed by a tcMod.
-  virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber) {}
+  virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber, bool LiveView) {}
                // Indicates a channel switch on the given DVB device.
                // If ChannelNumber is 0, this is before the channel is being switched,
                // otherwise ChannelNumber is the number of the channel that has been switched to.
+               // LiveView tells whether this channel switch is for live viewing.
   virtual void Recording(const cDevice *Device, const char *Name, const char *FileName, bool On) {}
                // The given DVB device has started (On = true) or stopped (On = false) recording Name.
                // Name is the name of the recording, without any directory path. The full file name
@@ -85,7 +86,7 @@
   virtual ~cStatus();
   // These functions are called whenever the related status information changes:
   static void MsgTimerChange(const cTimer *Timer, eTimerChange Change);
-  static void MsgChannelSwitch(const cDevice *Device, int ChannelNumber);
+  static void MsgChannelSwitch(const cDevice *Device, int ChannelNumber, bool LiveView);
   static void MsgRecording(const cDevice *Device, const char *Name, const char *FileName, bool On);
   static void MsgReplaying(const cControl *Control, const char *Name, const char *FileName, bool On);
   static void MsgSetVolume(int Volume, bool Absolute);
diff -ruN vdr-1.7.25/svdrp.c vdr-1.7.26/svdrp.c
--- vdr-1.7.25/svdrp.c	2012-02-16 13:38:19.000000000 +0100
+++ vdr-1.7.26/svdrp.c	2012-03-04 13:05:56.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 2.15 2012/02/16 12:38:19 kls Exp $
+ * $Id: svdrp.c 2.16 2012/03/04 12:05:56 kls Exp $
  */
 
 #include "svdrp.h"
@@ -601,9 +601,13 @@
         Reply(501, "Undefined channel \"%s\"", Option);
      }
   else {
-     cSchedules::ClearAll();
      cEitFilter::SetDisableUntil(time(NULL) + EITDISABLETIME);
-     Reply(250, "EPG data cleared");
+     if (cSchedules::ClearAll()) {
+        Reply(250, "EPG data cleared");
+        cEitFilter::SetDisableUntil(time(NULL) + EITDISABLETIME);
+        }
+     else
+        Reply(451, "Error while clearing EPG data");
      }
 }
 
@@ -1600,6 +1604,7 @@
         Reply(PUTEhandler->Status(), "%s", PUTEhandler->Message());
         DELETENULL(PUTEhandler);
         }
+     cEitFilter::SetDisableUntil(time(NULL) + EITDISABLETIME); // re-trigger the timeout, in case there is very much EPG data
      return;
      }
   // skip leading whitespace:
diff -ruN vdr-1.7.25/vdr.5 vdr-1.7.26/vdr.5
--- vdr-1.7.25/vdr.5	2012-02-27 12:05:15.000000000 +0100
+++ vdr-1.7.26/vdr.5	2012-03-10 15:56:01.000000000 +0100
@@ -8,7 +8,7 @@
 .\" License as specified in the file COPYING that comes with the
 .\" vdr distribution.
 .\"
-.\" $Id: vdr.5 2.28 2012/02/27 11:05:15 kls Exp $
+.\" $Id: vdr.5 2.29 2012/03/10 14:56:01 kls Exp $
 .\"
 .TH vdr 5 "10 Feb 2008" "1.6" "Video Disk Recorder Files"
 .SH NAME
@@ -861,7 +861,7 @@
 <event id>     @is a 32 bit unsigned int, uniquely identifying this event
 <start time>   @is the time (as a time_t integer) in UTC when this event starts
 <duration>     @is the time (in seconds) that this event will take
-<table id>     @is a hex number that indicates the table this event is contained in (if this is left empty or 0 this event will not be overwritten or modified by data that comes from the DVB stream)
+<table id>     @is a hex number that indicates the table this event is contained in (if this is left empty it will be set to 0x00; and value less than 0x4E it will be treated as if it were 0x4E)
 <version>      @is a hex number that indicates the event's version number inside its table (optional, ignored when reading EPG data)
 <title>        @is the title of the event
 <short text>   @is the short text of the event (typically the name of the episode etc.)
diff -ruN vdr-1.7.25/vdr.c vdr-1.7.26/vdr.c
--- vdr-1.7.25/vdr.c	2012-02-27 11:59:55.000000000 +0100
+++ vdr-1.7.26/vdr.c	2012-03-09 10:55:15.000000000 +0100
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 2.30 2012/02/27 10:59:55 kls Exp $
+ * $Id: vdr.c 2.34 2012/03/09 09:55:15 kls Exp $
  */
 
 #include <getopt.h>
@@ -677,8 +677,8 @@
 
   // Default skins:
 
-  new cSkinClassic;
   new cSkinSTTNG;
+  new cSkinClassic;
   Skins.SetCurrent(Setup.OSDSkin);
   cThemes::Load(Skins.Current()->Name(), Setup.OSDTheme, Skins.Current()->Theme());
   CurrentSkin = Skins.Current();
@@ -761,10 +761,14 @@
            static time_t lastTime = 0;
            if ((!Menu || CheckHasProgramme) && Now - lastTime > MINCHANNELWAIT) { // !Menu to avoid interfering with the CAM if a CAM menu is open
               cChannel *Channel = Channels.GetByNumber(cDevice::CurrentChannel());
-              if (Channel && (Channel->Vpid() || Channel->Apid(0))) {
-                 if (!Channels.SwitchTo(cDevice::CurrentChannel()) // try to switch to the original channel...
-                     && !(LastTimerChannel > 0 && Channels.SwitchTo(LastTimerChannel))) // ...or the one used by the last timer...
+              if (Channel && (Channel->Vpid() || Channel->Apid(0) || Channel->Dpid(0))) {
+                 if (cDevice::GetDeviceForTransponder(Channel, LIVEPRIORITY) && Channels.SwitchTo(Channel->Number())) // try to switch to the original channel...
                     ;
+                 else if (LastTimerChannel > 0) {
+                    Channel = Channels.GetByNumber(LastTimerChannel);
+                    if (Channel && cDevice::GetDeviceForTransponder(Channel, LIVEPRIORITY) && Channels.SwitchTo(LastTimerChannel)) // ...or the one used by the last timer
+                       ;
+                    }
                  }
               lastTime = Now; // don't do this too often
               LastTimerChannel = -1;
@@ -878,31 +882,12 @@
                      }
                   if (NeedsTransponder || InVpsMargin) {
                      // Find a device that provides the required transponder:
-                     cDevice *Device = NULL;
-                     bool DeviceAvailable = false;
-                     for (int i = 0; i < cDevice::NumDevices(); i++) {
-                         cDevice *d = cDevice::GetDevice(i);
-                         if (d && d->ProvidesTransponder(Timer->Channel())) {
-                            if (d->IsTunedToTransponder(Timer->Channel())) {
-                               // if any device is tuned to the transponder, we're done
-                               Device = d;
-                               break;
-                               }
-                            if (d->MaySwitchTransponder(Timer->Channel())) {
-                               DeviceAvailable = true; // avoids using the actual device below
-                               Device = d;
-                               }
-                            else if (!d->Occupied() && !Device && InVpsMargin && !d->Receiving() && d->ProvidesTransponderExclusively(Timer->Channel()))
-                               Device = d; // use this one only if no other with less impact can be found
-                            }
-                         }
-                     if (!Device && InVpsMargin && !DeviceAvailable) {
-                        cDevice *d = cDevice::ActualDevice();
-                        if (!d->Receiving() && d->ProvidesTransponder(Timer->Channel()) && !d->Occupied())
-                           Device = d; // use the actual device as a last resort
-                        }
+                     cDevice *Device = cDevice::GetDeviceForTransponder(Timer->Channel(), MINPRIORITY);
+                     if (!Device && InVpsMargin)
+                        Device = cDevice::GetDeviceForTransponder(Timer->Channel(), LIVEPRIORITY);
                      // Switch the device to the transponder:
                      if (Device) {
+                        bool HadProgramme = cDevice::PrimaryDevice()->HasProgramme();
                         if (!Device->IsTunedToTransponder(Timer->Channel())) {
                            if (Device == cDevice::ActualDevice() && !Device->IsPrimaryDevice())
                               cDevice::PrimaryDevice()->StopReplay(); // stop transfer mode
@@ -910,13 +895,8 @@
                            if (Device->SwitchChannel(Timer->Channel(), false))
                               Device->SetOccupied(TIMERDEVICETIMEOUT);
                            }
-                        if (cDevice::PrimaryDevice()->HasDecoder() && !cDevice::PrimaryDevice()->HasProgramme()) {
-                           // the previous SwitchChannel() has switched away the current live channel
-                           cDevice::SetAvoidDevice(Device);
-                           if (!Channels.SwitchTo(cDevice::CurrentChannel())) // try to switch to the original channel on a different device...
-                              Channels.SwitchTo(Timer->Channel()->Number()); // ...or avoid toggling between old channel and black screen
-                           Skins.Message(mtInfo, tr("Upcoming recording!"));
-                           }
+                        if (cDevice::PrimaryDevice()->HasDecoder() && HadProgramme && !cDevice::PrimaryDevice()->HasProgramme())
+                           Skins.Message(mtInfo, tr("Upcoming recording!")); // the previous SwitchChannel() has switched away the current live channel
                         }
                      }
                   }
@@ -1320,6 +1300,7 @@
      Setup.Save();
      }
   cDevice::Shutdown();
+  EpgHandlers.Clear();
   PluginManager.Shutdown(true);
   cSchedules::Cleanup(true);
   ReportEpgBugFixStats();
